// -------------------------------------------------------------------------
//   qSOAPman
//   Copyright (C) 2004 by Jan Schreiber
//   mail@jschreiber.com
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
//   Free Software Foundation, Inc.,
//   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// -------------------------------------------------------------------------


#ifndef QSOAPMAN_H
#  define QSOAPMAN_H

#include <qmainwindow.h>
#include <qdatetime.h>
#include "mainsoapwidget.h"

class qsoapman: public QMainWindow
{
	Q_OBJECT

public:
	qsoapman();
	virtual ~qsoapman();

protected:
	void closeEvent( QCloseEvent* );

private slots:
	void newDoc();
	void choose();
	void load( const QString &fileName );
	void save();
	void saveAs();
//    void print();

	void about();
	void aboutQt();
	void startRequestSlot();
	void endRequestSlot();

private:
  //  QPrinter *printer;

  	QString encodeSGMLEntities( const QString& ) const;
	QString decodeSGMLEntities( const QString &s ) const;

	MainSOAPWidget *soapwidget;
	QString filename;
	QTime timer;
};


#endif
