// -------------------------------------------------------------------------
//   qSOAPman
//   Copyright (C) 2004 by Jan Schreiber
//   mail@jschreiber.com
//
//   This program is free software; you can redistribute it and/or modify
//   it under the terms of the GNU General Public License as published by
//   the Free Software Foundation; either version 2 of the License, or
//   (at your option) any later version.
//
//   This program is distributed in the hope that it will be useful,
//   but WITHOUT ANY WARRANTY; without even the implied warranty of
//   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//   GNU General Public License for more details.
//
//   You should have received a copy of the GNU General Public License
//   along with this program; if not, write to the
//   Free Software Foundation, Inc.,
//   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// -------------------------------------------------------------------------

#ifndef SOAPSYNTAXHIGHLIGHTER_H
#  define SOAPSYNTAXHIGHLIGHTER_H

#include <qxml.h>

class QString;

class SOAPSyntaxHighlighter : public QXmlDefaultHandler
{
public:
	SOAPSyntaxHighlighter();
	bool startDocument();
	bool startElement( const QString&, const QString&, const QString& ,
		const QXmlAttributes& );
	bool endElement( const QString&, const QString&, const QString& );
	bool processingInstruction ( const QString & target, const QString & data );
	bool characters ( const QString & ch );
	bool comment( const QString & ch );
	//bool startEntity ( const QString & name );
	bool startCDATA ();
	bool endCDATA();
	
	QString getResult();

private:
	QString encodeXMLEntities( const QString& ) const;
	
	QString indent;
	QString result;
	bool startedElement;
	bool inCDATA;

	QString XMLProcessingMarkupColor;
	QString XMLElementColor;
	QString XMLDataColor;
	QString XMLDTDColor;
	QString XMLAttributeNameColor;
	QString XMLAttributeValueColor;
	QString XMLCommentColor;
	QString XMLErrorColor;
	QString XMLCDATATagColor;
	QString XMLCDATAColor;
};

#endif
